//  -   
//
unit automats;

interface
uses stdctrls, classes, extctrls, sysutils, cards, log_unit;

const
    insert_card       : boolean = false;
    extract_card      : boolean = false;
    print_receipt     : boolean = false;
    drawout_money     : boolean = false;
    drawin_money      : boolean = false;
    receipt_requested : boolean = false;
    requested_money   : integer = 0;

type
  TAutomats = class
    screen       : TStrings;
    y0,
    y1,
    y2           : integer;
    pin,
    pin_mask     : String;
    card_timer,
    money_timer  : TTimer;
    card         : TCard;
    card_info    : TLabel;
    constructor Create (lines : TStrings);

    procedure A0( e : integer );
    procedure A1( e : integer );
    procedure A2( e : integer );

    function x1 : boolean;            //   4  PIN-
    function x2 : boolean;            // PIN-  
    function x3 : boolean;            //    
    function x4 : boolean;            //   


    procedure z100;                   //      
    procedure z101;                   //   PIN-
    procedure z102;                   //       
    procedure z103;                   //    
    procedure z104;                   //      
    procedure z105;                   //      
    procedure z106;                   //      
    procedure z107;                   //        PIN
    procedure z108;                   //         
    procedure z109;                   //      
    procedure z110;                   //      
    procedure z30;                    //   "0"  PIN
    procedure z31;                    //   "1"  PIN
    procedure z32;                    //   "2"  PIN
    procedure z33;                    //   "3"  PIN
    procedure z34;                    //   "4"  PIN
    procedure z35;                    //   "5"  PIN
    procedure z36;                    //   "6"  PIN
    procedure z37;                    //   "7"  PIN
    procedure z38;                    //   "8"  PIN
    procedure z39;                    //   "9"  PIN
    procedure z5;                     //  
    procedure z4;                     //    PIN
    procedure z40;                    //   "0"  
    procedure z41;                    //   "1"  
    procedure z42;                    //   "2"  
    procedure z43;                    //   "3"  
    procedure z44;                    //   "4"  
    procedure z45;                    //   "5"  
    procedure z46;                    //   "6"  
    procedure z47;                    //   "7"  
    procedure z48;                    //   "8"  
    procedure z49;                    //   "9"  
    procedure z61;                    //    3000 
    procedure z62;                    //    2000 
    procedure z63;                    //    1500 
    procedure z64;                    //    1000 
    procedure z65;                    //    500 
    procedure z66;                    //    200 
    procedure z67;                    //    100 
    procedure z68;                    //    
    procedure z69;                    //    
    procedure z7;                     //  
    procedure z71;                    //    
    procedure z72;                    //    
    procedure z81;                    //    
    procedure z82;                    //    
    procedure z83;                    //    
  end;

implementation

constructor TAutomats.Create;
begin
    card := TCard.Create;
    screen := lines;
    y0     := 0;
    y1     := 0;
    y2     := 0;
end;

//
//  :   4  PIN
//
function TAutomats.x1 : boolean;
var ret : boolean;
begin
    ret := length(pin) < 4;
    log.add_input( 1, '  4  PIN', ret );
    x1 := ret;
end;

//
//   : PIN  
//
function TAutomats.x2 : boolean;
var ret : boolean;
begin
    ret := pin <> card.getPIN;
    log.add_input( 2, 'PIN  ', ret );
    x2 := ret;
end;

//
//  :    
//
function TAutomats.x3 : boolean;
var ret : boolean;
begin
    ret := requested_money > card.getMoney;
    log.add_input( 3, '   ', ret );
    x3 := ret;
end;

//
//  :   
//
function TAutomats.x4 : boolean;
var ret : boolean;
begin
    ret := receipt_requested;
    log.add_input( 3, '   ', ret );
    x4 := ret;
end;

//  :
//      
procedure TAutomats.z100;
begin
    log.add_action( 100, '     ' );
    screen.Clear;
    screen.Add( ' ' );
    card_timer.Enabled := false;
    money_timer.Enabled := false;
end;

//  :
//   PIN
procedure TAutomats.z101;
begin
    log.add_action( 101, '     PIN-' );
    screen.Clear;
    pin := ''; pin_mask := '';
    screen.Add( '    ' );
    screen.Add( '  ' );
end;

//  :
//       
procedure TAutomats.z102;
begin
    log.add_action( 102, '      ' );
    screen.Clear;
    screen.Add( ' ' );
    screen.Add( ' ' );
end;

//  :
//    
procedure TAutomats.z103;
begin
    log.add_action( 103, '   ' );
    screen.Clear;
    screen.Add( ' ' );
    screen.Add( ' ' );
    screen.Add( '             ' );
    screen.Add( '              ' );
    screen.Add( '              ' );
end;

//  :
//      
procedure TAutomats.z104;
begin
    log.add_action( 104, '     ' );
    requested_money := 0;
    screen.Clear;
    screen.Add( ' ' );
    screen.Add( '  ' );
    screen.Add( '3000                         500' );
    screen.Add( '2000                         200' );
    screen.Add( '1500                         100' );
    screen.Add( '1000                     ' );
end;

//  :
//      
procedure TAutomats.z105;
begin
    log.add_action( 105, '      ' );
    screen.Clear;
    screen.Add( ' ?' );
    screen.Add( '' );
    screen.Add( '' );
    screen.Add( '' );
    screen.Add( '                                  ' );
    screen.Add( '                                 ' );
end;

//  :
//      
procedure TAutomats.z106;
begin
    log.add_action(106, '     ' );
    screen.Clear;
    screen.Add( ' :' );
end;

//  :
//        PIN
procedure TAutomats.z107;
begin
    log.add_action(107, '       PIN-' );
    screen.Clear;
    screen.Add( '    ' );
    screen.Add( '   ' );
    screen.Add( '    ?' );
    screen.Add( '' );
    screen.Add( '                                 ' );
    screen.Add( '                                ' );
end;

//  :
//         
procedure TAutomats.z108;
begin
    log.add_action( 108, '        ' );
    screen.Clear;
    screen.Add( '   ' );
    screen.Add( '  ?' );
    screen.Add( '' );
    screen.Add( '' );
    screen.Add( '                                 ' );
    screen.Add( '                                ' );
end;

//  :
//      
procedure TAutomats.z109;
begin
    log.add_action( 109, '     ' );
    screen.Clear;
    screen.Add( ', ,' );
    screen.Add( ' ' );
end;

//  :
//      
procedure TAutomats.z110;
begin
    log.add_action(110, '     ' );
    screen.Clear;
    screen.Add( ' ' );
end;

//  :
//   "0"  PIN
procedure TAutomats.z30;
begin
    log.add_action( 30, '  "0"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '0';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "1"  PIN
procedure TAutomats.z31;
begin
    log.add_action( 31, '  "1"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '1';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "2"  PIN
procedure TAutomats.z32;
begin
    log.add_action( 32, '  "2"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '2';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "3"  PIN
procedure TAutomats.z33;
begin
    log.add_action( 33, '  "3"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '3';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "4"  PIN
procedure TAutomats.z34;
begin
    log.add_action( 34, '  "4"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '4';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "5"  PIN
procedure TAutomats.z35;
begin
    log.add_action( 35, '  "5"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '5';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "6"  PIN
procedure TAutomats.z36;
begin
    log.add_action( 36, '  "6"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '6';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "7"  PIN
procedure TAutomats.z37;
begin
    log.add_action( 37, '  "7"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '7';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "8"  PIN
procedure TAutomats.z38;
begin
    log.add_action( 38, '  "8"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '8';
    screen[2] := '      ' + pin_mask;
end;

//  :
//   "9"  PIN
procedure TAutomats.z39;
begin
    log.add_action( 39, '  "9"  PIN' );
    pin_mask  := pin_mask + 'X';
    pin       := pin + '9';
    screen[2] := '      ' + pin_mask;
end;

//  :
//  
procedure TAutomats.z5;
begin
    log.add_action( 5, ' ');
    print_receipt := true;
end;

//  :
//    PIN
procedure TAutomats.z4;
begin
    log.add_action( 4, '   PIN' );
    pin := '';
    pin_mask := '';
    screen[2] := '';
end;

//  :
//   "0"  
procedure TAutomats.z40;
begin
    log.add_action( 40, '  "0"  ' );
    requested_money := requested_money * 10 + 0;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "1"  
procedure TAutomats.z41;
begin
    log.add_action( 41, '  "1"  ' );
    requested_money := requested_money * 10 + 1;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "2"  
procedure TAutomats.z42;
begin
    log.add_action( 42, '  "2"  ' );
    requested_money := requested_money * 10 + 2;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "3"  
procedure TAutomats.z43;
begin
    log.add_action( 43, '  "3"  ' );
    requested_money := requested_money * 10 + 3;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "4"  
procedure TAutomats.z44;
begin
    log.add_action( 44, '  "4"  ' );
    requested_money := requested_money * 10 + 4;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "5"  
procedure TAutomats.z45;
begin
    log.add_action( 45, '  "5"  ' );
    requested_money := requested_money * 10 + 5;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "6"  
procedure TAutomats.z46;
begin
    log.add_action( 46, '  "6"  ' );
    requested_money := requested_money * 10 + 6;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "7"  
procedure TAutomats.z47;
begin
    log.add_action( 47, '  "7"  ' );
    requested_money := requested_money * 10 + 7;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "8"  
procedure TAutomats.z48;
begin
    log.add_action( 48, '  "8"  ' );
    requested_money := requested_money * 10 + 8;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//   "9"  
procedure TAutomats.z49;
begin
    log.add_action( 49, '  "9"  ' );
    requested_money := requested_money * 10 + 9;
    screen[1] := '    ' + IntToStr( requested_money );
end;

//  :
//    3000 
procedure TAutomats.z61;
begin
    log.add_action( 61, '   3000 ' );
    requested_money := 3000;
end;

//  :
//    2000 
procedure TAutomats.z62;
begin
    log.add_action( 62, '   2000 ' );
    requested_money := 2000;
end;

//  :
//    1500 
procedure TAutomats.z63;
begin
    log.add_action( 63, '   1500 ' );
    requested_money := 1500;
end;

//  :
//    1000 
procedure TAutomats.z64;
begin
    log.add_action( 64, '   1000 ');
    requested_money := 1000;
end;

//  :
//    500 
procedure TAutomats.z65;
begin
    log.add_action( 65, '   500 ' );
    requested_money := 500;
end;

//  :
//    200 
procedure TAutomats.z66;
begin
    log.add_action( 66, '   200 ');
    requested_money := 200;
end;

//  :
//    100 
procedure TAutomats.z67;
begin
    log.add_action( 67, '   100 ' );
    requested_money := 100;
end;

//  :
//    
procedure TAutomats.z68;
begin
    log.add_action( 68, '   ' );
    requested_money := 0;
    screen[1] := ' ';
end;

//  :
//    
procedure TAutomats.z69;
begin
    log.add_action( 69, '   ' );
    receipt_requested := true;
end;

//  :
//  
procedure TAutomats.z7;
begin
    log.add_action( 7, ' ' );
    drawout_money := true;
    card.withdraw( requested_money );
    card_info.Caption := 'PIN- :  ' + card.getPIN + #13 +
                         ':     ' + IntToStr(card.getMoney);
end;

//  :
//    
procedure TAutomats.z71;
begin
    log.add_action(71, '   ' );
    money_timer.Enabled := true;
end;

//  :
//    
procedure TAutomats.z72;
begin
    log.add_action( 72, '   ' );
    drawin_money := true;
end;

//  :
//    
procedure TAutomats.z81;
begin
    log.add_action( 81, '   ' );
    card_timer.Enabled := true;
end;

//  :
//    
procedure TAutomats.z82;
begin
    log.add_action( 82, '   ' );
    insert_card := true;
end;

//  :
//    
procedure TAutomats.z83;
begin
    log.add_action( 83, '   ' );
    extract_card := true;
end;


//
//  A0
//
procedure TAutomats.A0( e : integer );
var
    y_old : integer;
begin
  y_old := y0;
  log.add_begin( 0, y0, e );
  case y0 of
  0:
      if y2 = 1 then begin
                                                 y0 := 1;
      end;
  1:
      if x1 and ( e = 20 ) then begin
                      z30;                       y0 := 1;
      end else if x1 and ( e = 21 ) then begin
                      z31;                       y0 := 1;
      end else if x1 and ( e = 22 ) then begin
                      z32;                       y0 := 1;
      end else if x1 and ( e = 23 ) then begin
                      z33;                       y0 := 1;
      end else if x1 and ( e = 24 ) then begin
                      z34;                       y0 := 1;
      end else if x1 and ( e = 25 ) then begin
                      z35;                       y0 := 1;
      end else if x1 and ( e = 26 ) then begin
                      z36;                       y0 := 1;
      end else if x1 and ( e = 27 ) then begin
                      z37;                       y0 := 1;
      end else if x1 and ( e = 28 ) then begin
                      z38;                       y0 := 1;
      end else if x1 and ( e = 29 ) then begin
                      z39;                       y0 := 1;
      end else if e = 4 then begin
                      z4;                        y0 := 1;
      end else if e = 5 then begin
                                                 y0 := 3;
      end else if e = 3 then begin
                                                 y0 := 2;
      end;
  2:
      if ( y2 = 0 ) or ( y2 = 3 ) then begin
                                                 y0 := 0;
      end;
  3:
      if e = 65 then begin
                                                 y0 := 12;
      end else if ( e = 66 ) or ( e = 67 ) then begin
                      z5;                        y0 := 11;
      end else if e = 3 then begin
                                                 y0 := 2;
      end;
  4:
      if e = 61 then begin
                      z61;                       y0 := 5;
      end else if e = 62 then begin
                      z62;                       y0 := 5;
      end else if e = 63 then begin
                      z63;                       y0 := 5;
      end else if e = 64 then begin
                      z64;                       y0 := 5;
      end else if e = 65 then begin
                      z65;                       y0 := 5;
      end else if e = 66 then begin
                      z66;                       y0 := 5;
      end else if e = 67 then begin
                      z67;                       y0 := 5;
      end else if e = 68 then begin
                                                 y0 := 6;
      end else if e = 3 then begin
                                                 y0 := 2;
      end;
  5:
      if x2 then begin
                                                 y0 := 7;
      end else if x3 then begin
                                                 y0 := 8;
      end else if not x4 then begin
                                                 y0 := 9;
      end else if x4 then begin
                      z5;                        y0 := 9;
      end;
  6:
      if e = 20 then begin
                      z40;                       y0 := 6;
      end else if e = 21 then begin
                      z41;                       y0 := 6;
      end else if e = 22 then begin
                      z42;                       y0 := 6;
      end else if e = 23 then begin
                      z43;                       y0 := 6;
      end else if e = 24 then begin
                      z44;                       y0 := 6;
      end else if e = 25 then begin
                      z45;                       y0 := 6;
      end else if e = 26 then begin
                      z46;                       y0 := 6;
      end else if e = 27 then begin
                      z47;                       y0 := 6;
      end else if e = 28 then begin
                      z48;                       y0 := 6;
      end else if e = 29 then begin
                      z49;                       y0 := 6;
      end else if e = 4 then begin
                      z68;                       y0 := 6;
      end else if e = 5 then begin
                                                 y0 := 5;
      end else if e = 3 then begin
                                                 y0 := 2;
      end;
  7:
      if e = 67 then begin
                                                 y0 := 1;
      end else if ( e = 68 ) or ( e = 3 ) then begin
                                                 y0 := 2;
      end;
  8:
      if e = 67 then begin
                                                 y0 := 4;
      end else if ( e = 68 ) or ( e = 3 ) then begin
                                                 y0 := 2;
      end;
  9:
      if y2 = 0 then begin
                                                 y0 := 10;
      end else if y2 = 3 then begin
                                                 y0 := 0;
      end else if e = 3 then begin
                                                 y0 := 2;
      end;
  10:
      if y1 = 0 then begin
                                                 y0 := 0;
      end else if e = 3 then begin
                                                 y0 := 2;
      end;
  11:
      if ( y2 = 0 ) or ( y2 = 3 ) or ( e = 3 ) then begin
                                                 y0 := 0;
      end;
  12:
      if e = 67 then begin
                      z69;                       y0 := 4;
      end else if e = 68 then begin
                                                 y0 := 4;
      end else if e = 3 then begin
                                                 y0 := 2;
      end;
  else
      log.add_error( 0, ' ' );
  end;
  if y0 <> y_old then begin
    log.add_trans( 0, y_old, y0 );
    case y0 of
    0:
        z100;
    1:
        z101;
    2:
        begin
          z102; A2( 8 );
        end;
    3:
        z103;
    4:
        z104;
    6:
        z106;
    7:
        z107;
    8:
        z108;
    9:
        begin
          z109; A2( 8 );
        end;
    10:
        begin
          z110; A1( 7 );
        end;
    11:
        begin
          z109; A2( 8 );
        end;
    12:
        z105;
    end;
  end;
  log.add_end( 0, y0, e );
end;

//
//  A1
//
procedure TAutomats.A1( e : integer );
var y_old : integer;
begin
  y_old := y1;
  log.add_begin( 1, y1, e );
  case y1 of
  0:
      if e = 7 then begin
                      z71; z7;                   y1 := 1;
      end;
  1:
      if e = 71 then begin
                                                 y1 := 0;
      end else if e = 72 then begin
                      z72;                       y1 := 0;
      end;
  else
      log.add_error( 1, ' ' );
  end;
  if y_old <> y1 then
      log.add_trans( 1, y_old, y1 );
  log.add_end( 1, y1, e );
end;

//
//  A2
//
procedure TAutomats.A2( e : integer );
var y_old : integer;
begin
  y_old := y2;
  log.add_begin( 2, y2, e );
  case y2 of
  0:
      if e = 1 then begin
                      z82;                       y2 := 1;
      end;
  1:
      if e = 8 then begin
                      z81; z83;                  y2 := 2;
      end;
  2:
      if e = 81 then begin
                                                 y2 := 0;
      end else if e = 82 then begin
                      z82;                       y2 := 3;
      end;
  else
      log.add_error( 2, ' ' );
  end;
  if y_old <> y2 then
      log.add_trans( 2, y_old, y2 );
  log.add_end( 2, y2, e );
end;

end.
