//  
//
unit log_unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TLog = class(TForm)
    log_memo: TMemo;
    Button1: TButton;
    Button2: TButton;
    logBegin: TCheckBox;
    logTrans: TCheckBox;
    logEnd: TCheckBox;
    logInput: TCheckBox;
    logAction: TCheckBox;
    logt0: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure add_log( str : String );
//
//    
//
    procedure add_begin( aut, state, event : integer );
//
//    
//
    procedure add_trans( aut, old_state, new_state : integer );
//
//    
//
    procedure add_end( aut, state, event : integer );
//
//    
//
    procedure add_input( num : integer; str : string; ret : boolean);
//
//   
//
    procedure add_action( num : integer; str : string );
//
//    
//
    procedure add_error( aut : integer; err : string );
//
//     
//
    procedure add( str : String );
  end;

var
  Log: TLog;

implementation

{$R *.DFM}

procedure TLog.Button1Click(Sender: TObject);
begin
  Hide;
end;

procedure TLog.add( str : String );
begin
  log_memo.Lines.Add(TimeToStr(Time) + '  ' + str);
end;

procedure TLog.add_log( str : String );
begin
  add( '# ' + str );
end;

procedure TLog.add_begin( aut, state, event : integer );
begin
  if ( event = 0 ) and ( not logt0.Checked ) then exit;
  if logBegin.Checked then
      add( '{ A' + IntToStr( aut ) + ':   ' + IntToStr( state ) +
                    '    e' + IntToStr( event ) );
end;

procedure TLog.add_trans( aut, old_state, new_state : integer );
begin
  if logTrans.Checked then
      add( 'T A' + IntToStr( aut ) + ':    ' +
           IntToStr( old_state ) + '   ' + IntToStr(new_state) );
end;

procedure TLog.add_end( aut, state, event : integer );
begin
  if ( event = 0 ) and ( not logt0.Checked ) then exit;
  if logEnd.Checked then
      add( '} A' + IntToStr( aut ) + ':    e' +
           IntToStr( event ) + '   ' + IntToStr( state ));
end;

procedure TLog.add_input( num : integer; str : string; ret : boolean);
var s : String;
begin
  if ret then s := 'true' else s := 'false';
  if logInput.Checked then
      add( '> x' + IntToStr( num ) + ' - ' + str + ' -  ' + s  );
end;

procedure TLog.add_action( num : integer; str : string );
begin
  if logAction.Checked then
      add( '* z' + IntToStr( num ) + ' - ' + str );
end;

procedure TLog.add_error( aut : integer; err : string );
begin
  add( '! A' + IntToStr( aut ) + ': : ' + err );
end;


procedure TLog.Button2Click(Sender: TObject);
begin
  log_memo.Clear;
end;


end.
